/*
 * context_enhance_open_list.h
 *
 *  Created on: 25.04.2014
 *      Author: lukas
 */

#ifndef CONTEXT_ENHANCE_OPEN_LIST_H_
#define CONTEXT_ENHANCE_OPEN_LIST_H_

#include "open_list.h"
#include "../option_parser.h"
#include "../search_space.h"
#include <vector>

class ScalarEvaluator;

template<class Entry>
class ContextEnhanceOpenList: public OpenList<Entry> {

	int index_t; //index von operator t (für innocent-prüfung)
	int queueIndex; //this is the interference distance
	int size; //Summe aller Elemente
	ScalarEvaluator *evaluator;
	bool dead_end;
	bool dead_end_reliable;

	std::vector<OpenList<Entry> *> open_lists;
	//std::vector<int> priorities;
	bool isInnocent();

public:
	ContextEnhanceOpenList(const Options &opts);
	ContextEnhanceOpenList(ScalarEvaluator *eval, bool preferred_only);

	void init(int numberOfQueues);
	void setQueueIndex(int n);
	void setPrevCreatingOperator(int index_t);

	int insert(const Entry &entry);
	Entry remove_min(std::vector<int> *key = 0);
	bool empty() const;
	void clear();
	void evaluate(int g, bool preferred);

	bool is_dead_end() const;
	bool dead_end_is_reliable() const;
	void get_involved_heuristics(std::set<Heuristic *> &hset);

protected:
	ScalarEvaluator *get_evaluator() {
		return evaluator;
	}
};

#include "context_enhance_open_list.cc"

#endif /* CONTEXT_ENHANCE_OPEN_LIST_H_ */
